Attribute VB_Name = "TigraMenu"
' Frontpage VBA Macro to create a menu definition file for TigraMenu v2.0
' see http://www.softcomplex.com/products/tigra_menu/


Option Explicit

Const OUTPUT_FILE As String = "menu_items.js"       ' name of the item definition file in the current web

Sub BuildTGMenu()
    'Main procedure to build the tigra menu based on the fronpage navigation structure

    If ActiveWeb Is Nothing Then
            MsgBox "Please open a web first to build the menu file !", vbOKOnly Or vbCritical
            Exit Sub
    End If
    Open ActiveWeb.RootFolder.Name + "\" + OUTPUT_FILE For Output As #1
    Print #1, "var MENU_ITEMS = ["
    Print #1, BuildTGSubMenu(ActiveWeb.RootNavigationNode, 0)
    Print #1, "];"
    Close #1
End Sub

Function BuildTGSubMenu(ByRef node As NavigationNode, level As Integer) As String

    Dim childNode As NavigationNode

    If (Not node Is ActiveWeb.RootNavigationNode) Then  ' handle special case rootnode
        If node.InNavBars Then                          ' ignore excluded pages
            BuildTGSubMenu = Space(level * 4) + "['" + HTMLUmlaut(node.Label) + "','/" & MakeRel(ActiveWeb, node.Url) + "',null"
            If node.Children.count = 0 Then
                BuildTGSubMenu = BuildTGSubMenu + "]," + vbCrLf                              ' close submenu
            Else
                BuildTGSubMenu = BuildTGSubMenu + "," + vbCrLf                               ' close line partially
            End If
        End If
    End If
    If node.Children.count > 0 Then
        For Each childNode In node.Children
            BuildTGSubMenu = BuildTGSubMenu & BuildTGSubMenu(childNode, level + 1)          ' process child navigation nodes
        Next
        If level > 0 Then
            BuildTGSubMenu = BuildTGSubMenu & Space(level * 4) + "]," + vbCrLf              ' close parent menu if not top level menu
        End If
    End If
End Function



Function HTMLUmlaut(ByVal s As String) As String
    'Encode german umlauts, not all special characters are handled currently
    
    s = Replace(s, "&", "&amp;")
    s = Replace(s, "<", "&lt;")
    s = Replace(s, ">", "&gt;")
    s = Replace(s, """", "&quot;")
    s = Replace(s, "", "&auml;")
    s = Replace(s, "", "&ouml;")
    s = Replace(s, "", "&uuml;")
    s = Replace(s, "", "&Auml;")
    s = Replace(s, "", "&Ouml;")
    s = Replace(s, "", "&Uuml;")
    s = Replace(s, "", "&szlig;")
    s = Replace(s, " ", "&nbsp;")
    HTMLUmlaut = s
End Function
